.\" Process this file with
.\" groff -man -Tascii tcldes.n
.\"
.\" This software is copyrighted (c) 2003 by Mac A. Cody.  All rights
.\" reserved.  The following terms apply to all files associated with
.\" the software unless explicitly disclaimed in individual files or
.\" directories.

.\" The authors hereby grant permission to use, copy, modify, distribute,
.\" and license this software for any purpose, provided that existing
.\" copyright notices are retained in all copies and that this notice is
.\" included verbatim in any distributions. No written agreement, license,
.\" or royalty fee is required for any of the authorized uses.
.\" Modifications to this software may be copyrighted by their authors and
.\" need not follow the licensing terms described here, provided that the
.\" new terms are clearly indicated on the first page of each file where
.\" they apply.

.\" IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
.\" FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
.\" ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
.\" DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.

.\" THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
.\" FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
.\" IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
.\" NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
.\" MODIFICATIONS.

.\" GOVERNMENT USE: If you are acquiring this software on behalf of the
.\" U.S. government, the Government shall have only "Restricted Rights"
.\" in the software and related documentation as defined in the Federal 
.\" Acquisition Regulations (FARs) in Clause 52.227.19 (c) (2).  If you
.\" are acquiring the software on behalf of the Department of Defense, the
.\" software shall be classified as "Commercial Computer Software" and the
.\" Government shall have only "Restricted Rights" as defined in Clause
.\" 252.227-7013 (c) (1) of DFARs.  Notwithstanding the foregoing, the
.\" authors grant the U.S. Government and others acting in its behalf
.\" permission to use and distribute the software in accordance with the
.\" terms specified in this license.
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" RCS: @(#) $Id: man.macros,v 1.3.12.1 2001/04/03 22:06:43 hobbs Exp $
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH TclDES n "FEBRUARY 2003" Tcl "Tcl DES/3DES Library"
.SH NAME
TclDES \- Tcl-based Data Encryption Standard library
.SH SYNOPSIS

\fB package require tclDES ?0.5?\fR
.sp
\fB::des::des \fIkey message encrypt\fR [\fImode\fR [\fIiv\fR]]
.sp
\fB::des::encrypt \fIkey plaintext\fR [\fImode\fR [\fIiv\fR]]
.sp
\fB::des::decrypt \fIkey ciphertext\fR [\fImode\fR [\fIiv\fR]]
.sp
\fB::des::createKeys \fIkey\fR
.BE

.SH DESCRIPTION
.PP
\fBTclDES\fR is a pure-Tcl implementation of the NIST Data Encryption Standard
(DES). The package can perform encryption and decryption using either the
standard DES algorithm or the triple-DES (3DES) algorithm. Both Electronic
Code Block (ECB) and Cipher Block Chaining (CBC) modes of operation are
supported. A goal is to support Cipher FeedBack (CFB) and Output FeedBack
(OFB) modes as well.
.PP
This source code is being made publicly available and has been registered
with the U.S. Dept. of Commerce Bureau of Industry and Security under
export license exception TSU (Technology and Software Unrestricted) for
export out of the United States. \fBTclDES\fR is licensed under the same
Open Source license as Tcl (BSD). Details can be found in the \fBTclDES\fR
source code.
.PP
The TclDES commands are contained within the namespace \fB::des\fR so that
working variables shared between the commands are isolated from the global
namespace.
.SH COMMANDS
.TP
\fB::des::des \fIkey message encrypt\fR [\fImode\fR [\fIiv\fR]]
The \fB::des::des\fR command executes the DES/3DES algorithm. The input
\fIkey\fR must be a binary string of 8 bytes in length if the standard DES
algorithm will be executed.  The binary string must be 24 bytes in length
if the 3DES algorithm will be executed. \fIMessage\fR is a binary string
that will either be encrypted or decrypted depending on the value of the
\fIencrypt\fR flag.  If encryption is being performed, the length of
\fImessage\fR is extended to an integral multiple of eight bytes.  If
decryption is being performed, the length of \fImessage\fR must be an
integral multiple of eight bytes.  Encryption occurs if the \fIencrypt\fR
flag in 1 (the default) and decryption occurs if the flag is 0.  The
\fImode\fR flag determines the DES operation mode.  The modes available
are: 0 - Electronic Code Block (ECB, the default), 1 - Cipher Block
Chaining (CBC).  If the mode selected is CBC, a binary input vector string,
\fIiv\fR, must be supplied.  The binary string must be 8 bytes in length.
The output is a binary string of the encrypted or decrypted form of
\fImessage\fR. The length of the output string is always an integral
multiple of eight.
.TP
\fB::des::encrypt \fIkey plaintext\fR [\fImode\fR [\fIiv\fR]]
The \fB::des::encrypt\fR command is an encryption-only wrapper for the
\fB::des::des\fR command. The inputs \fIkey\fR, \fImode\fR, and \fIiv\fR
are defined as described in the \fB::des::des\fR command.  The input
\fIplaintext\fR is a binary string to be encrypted. If necessary, the
length of \fIplaintext\fR is extended to an integral multiple of eight
bytes.  The output is a binary string of the encrypted form of
\fIplaintext\fR.  The length of the output string is always an integral
multiple of eight bytes.
.TP
\fB::des::decrypt \fIkey ciphertext\fR [\fImode\fR [\fIiv\fR]]
The \fB::des::decrypt\fR command is a decryption-only wrapper for the
\fB::des::des\fR command. The inputs \fIkey\fR, \fImode\fR, and \fIiv\fR
are defined as described in the \fB::des::des\fR command.  The input
\fIciphertext\fR is a binary string to be decrypted. The length of
\fIciphertext\fR must be an integral multiple of eight bytes.  The output
is a binary string of the decrypted form of \fIciphertext\fR.  The length
of the output string is always an integral multiple of eight bytes.
.TP
\fB::des::createKeys \fIkey\fR
The \fB::des::createKeys\fR command generates the 16 or 48 subkeys used
by the DES and 3DES algorithms, respectively.  The input \fIkey\fR must
be a binary string of 8 bytes in length if 16 subkeys are to be created.
The binary string must be 24 bytes in length if 48 subkeys are to be
created.  The output is a list of subkeys either 16 or 24 elements in
length.  This command is used internally by the \fB::des::des\fR command.

.SH AUTHOR
Mac A. Cody <maccody at attbi dot com>

.SH "SEE ALSO"
binary(n)

.SH KEYWORDS
DES, 3DES, Tcl, package